#pragma once
#include "../acl_cpp_define.hpp"
#include "HttpServlet.hpp"

namespace acl
{

class websocket;
class session;

class WebSocketServlet: public HttpServlet
{
public:
	WebSocketServlet(void);

	/**
	 * 캯
	 * @param stream {socket_stream*}  acl_master ܿ
	 *  ʱòǿգ apache  CGI ʽʱò
	 *  Ϊ NULL⣬úڲرӣӦӦд
	 *  ĹرԷ acl_master ܹ
	 * @param session {session*} ÿһ HttpServlet һ session 
	 */
	WebSocketServlet(socket_stream* stream, session* session);

	/**
	 * 캯
	 * @param stream {socket_stream*}  acl_master ܿ
	 *  ʱòǿգ apache  CGI ʽʱò
	 *  Ϊ NULL⣬úڲرӣӦӦд
	 *  ĹرԷ acl_master ܹ
	 * @param memcache_addr {const char*}
	 */
	WebSocketServlet(socket_stream* stream,
		const char* memcache_addr = "127.0.0.1:11211");

	/**
	 * HttpServlet ʼУ HTTP 󣬲ص doXXX 麯
	 * úȻ start ̣Ȼ start ķؽ/Ӧ
	 * ǷҪ󱣳ֳǷҪͻ˱ֳ.
	 * @return {bool} ش false ʾʧܻɹ
	 *  ֳӣӦر
	 */

	virtual ~WebSocketServlet(void);

	/**
	 * HttpServlet ʼУ HTTP 󣬲ص doXXX 麯
	 * @param session {session&} 洢 session ݵĶ
	 * @param stream {socket_stream*}  acl_master ܿ
	 *  ʱòǿգ apache  CGI ʽʱò
	 *  Ϊ NULL⣬úڲرӣӦӦд
	 *  ĹرԷ acl_master ܹ
	 * @return {bool} ش
	 */
	virtual bool doRun(session& session, socket_stream* stream = NULL)
	{
		return HttpServlet::doRun(session, stream);
	}

	/**
	 * HttpServlet ʼУ HTTP 󣬲ص doXXX 麯
	 * ñζŲ memcached 洢 session 
	 * @param memcached_addr {const char*} memcached ַʽIP:PORT
	 * @param stream {socket_stream*} ͬ
	 * @return {bool} ش
	 */
	virtual bool doRun(const char* memcached_addr, socket_stream* stream)
	{
		return HttpServlet::doRun(memcached_addr, stream);
	}

	virtual bool doRun(void);

	/**
	 * Ͷ.
	 * @param rw_timeout {const char *} ͵
	 * @return {bool}  false. true
	 */

	bool send_binary(const char *buf, int len);

	/**
	 * ı.
	 * @param rw_timeout {const char *} ͵
	 * @return {bool}  false. true
	 */

	bool send_text(const char *text);

	/**
	 * pong Ϣ.
	 * @param rw_timeout {const char *} ͵
	 * @return {bool}  false. true
	 */
	bool send_pong(const char *buffer = NULL);

	/**
	 * pong Ϣ.
	 * @param rw_timeout {const char *} ͵
	 * @return {bool}  false. true
	 */
	bool send_ping(const char *buffer = NULL);

	unsigned long long get_max_msg_len(void) const
	{
		return max_msg_len_;
	}

	/**
	 * Ϣȣwebsocket ϢֵϿwebsocket.
	 * @param unsigned long long{len} µĳ
	 */
	void set_max_msg_len(unsigned long long len)
	{
		max_msg_len_ = len;
	}

protected:
	/**
	 * websocket رϢص
	 * @return {void}
	 */
	virtual void on_close(void);

	/**
	 * websocket ping Ϣص.
	 * @param {const char *} buf Ϣ
	 * @param {int} len Ϣݳ
	 * @return {bool} false Ͽӡ
	 */
	virtual bool on_ping(const char *buf, unsigned long long  len) = 0;

	/**
	 * websocket pong Ϣص.
	 * @param {const char *} buf Ϣ
	 * @param {int} len Ϣݳ
	 * @return {bool} false Ͽӡ
	 */
	virtual bool on_pong(const char *buf, unsigned long long  len) = 0;

	/**
	 * websocket ping Ϣص.
	 * @param data{char *} صݻ
	 * @param len{unsigned long long}صݻȡ
	 * @param text{bool } true Ϊıݡ ݡ
	 * @return {bool} false Ͽӡ
	 */
	virtual bool on_message(char *data, unsigned long long len, bool text) = 0;

private:
	// @override
	bool doWebsocket(HttpServletRequest&, HttpServletResponse&);

private:

	unsigned long long max_msg_len_;
	websocket *ws_;

	char *recv_buffer_;
	int write_pos_;
	int opcode_;
};

} // namespace acl
