#pragma once
#include "../acl_cpp_define.hpp"
#include "../stdlib/string.hpp"
#if defined(_WIN32) || defined(_WIN64)
#include <WinSock2.h>
#endif

namespace acl {

class socket_stream;

typedef enum {
	OPEN_FLAG_NONE      = 0,
	OPEN_FLAG_NONBLOCK  = 1,	// ģʽ
	OPEN_FLAG_REUSEPORT = 1 << 1,	// ˿ڸãҪ Linux3.0 
} open_flag_t;

/**
 * ˼׽ӿ࣬տͻӣͻӶ
 */
class ACL_CPP_API server_socket
{
public:
	/**
	 * 캯ñ캯෽ open ַָ
	 * @param backlog {int} ׽ӿڶг
	 * @param block {bool} ģʽǷģʽ
	 */
	explicit server_socket(int backlog = 128, bool block = true);

	/**
	 * 캯
	 * @param flag {unsigned} μ OPEN_FLAG_XXX
	 * @param backlog {int} ׽ӿڶг
	 */
	explicit server_socket(open_flag_t flag, int backlog = 128);

	/**
	 * 캯ñ캯ֹٵ open 
	 * @param sstream {ACL_VSTREAM*} ⲿļ󣬱ʹ
	 *  ͷţӦйرոü
	 */
	server_socket(ACL_VSTREAM* sstream);

	/**
	 * 캯ñ캯ֹٵ open 
	 * @param fd {ACL_SOCKET} ⲿļʹõͷţ
	 *  Ӧйرոü
	 */
#if defined(_WIN32) || defined(_WIN64)
	server_socket(SOCKET fd);
#else
	server_socket(int fd);
#endif

	~server_socket();

	/**
	 * ʼ˵ַ
	 * @param addr {const char*} ַʽΪ
	 *  ip:port unix £׽ӿڣʽΪ
	 *   /path/xxx
	 * @return {bool} Ƿɹ
	 */
	bool open(const char* addr);

	/**
	 * жϵǰ׽ӿǷ
	 * @return {bool}
	 */
	bool opened(void) const;

	/**
	 * رѾ򿪵ļ׽ӿ
	 * @return {bool} Ƿر
	 */
	bool close();

	/**
	 * ׽ӿڴӷн
	 * @return {SOCKET} رľ
	 */
#if defined(_WIN32) || defined(_WIN64)
	SOCKET unbind();
#else
	int unbind();
#endif

	/**
	 * տͻӲͻ
	 * @param timeout {int} ģʽ£ֵ > 0 ʱóʱ
	 *  ʽտͻӣָʱδÿͻӣ򷵻 NULL
	 * @return {socket_stream*} ؿձʾʧ
	 */
	socket_stream* accept(int timeout = 0);

	/**
	 * üĵַ
	 * @return {const char*} ֵǿָ
	 */
	const char* get_addr() const
	{
		return addr_.c_str();
	}

	/**
	 * ַñԻü׽ӿ
	 * @return {int}
	 */
#if defined(_WIN32) || defined(_WIN64)
	SOCKET sock_handle() const
#else
	int sock_handle() const
#endif
	{
		return fd_;
	}

	/**
	 * ü׽ֵӳٽչܣͻʱŽӷ
	 * ӦãĿǰù֧ܽ Linux
	 * @param timeout {int} ͻڹ涨ʱδݣ
	 *  ҲӷظӦ
	 */
	void set_tcp_defer_accept(int timeout);

private:
	int      backlog_;
	unsigned open_flag_;
	bool     unix_sock_;
	string   addr_;

#if defined(_WIN32) || defined(_WIN64)
	SOCKET fd_;
	SOCKET fd_local_;
#else
	int   fd_;
	int   fd_local_;
#endif
};

} // namespace acl
