#pragma once

class WebsocketServlet_impl : public acl::WebSocketServlet
{
public:
	WebsocketServlet_impl(acl::redis_client_cluster& cluster, size_t max_conns);
	~WebsocketServlet_impl();

	acl::session& get_session() const
	{
		return *session_;
	}

protected:
	virtual bool doUnknown(acl::HttpServletRequest&,
		acl::HttpServletResponse& res);
	virtual bool doGet(acl::HttpServletRequest& req,
		acl::HttpServletResponse& res);
	virtual bool doPost(acl::HttpServletRequest& req,
		acl::HttpServletResponse& res);


	//for websocket
	/**
	* websocket رϢص
	* @return {void}
	*/
	virtual void on_close()
	{

	}
	/**
	* websocket ping Ϣص.
	* @param {const char *} buf Ϣ
	* @param {int} len Ϣݳ
	* @return {bool} false Ͽӡ
	*/
	virtual bool on_ping(const char *buf, unsigned long long len);
	/**
	* websocket pong Ϣص.
	* @param {const char *} buf Ϣ
	* @param {int} len Ϣݳ
	* @return {bool} false Ͽӡ
	*/
	virtual bool on_pong(const char *buf, unsigned long long len);

	/**
	* websocket ping Ϣص.
	* @param data{char *} صݻ
	* @param len{unsigned long long}صݻȡ
	* @param text{bool } true Ϊıݡ ݡ
	* @return {bool} false Ͽӡ
	*/
	virtual bool on_message(char *data, unsigned long long len, bool text);

private:
	acl::session* session_;

	int step_;

	acl::string filename_;

	acl::ofstream *file_;

	int filesize_;

	int current_filesize_;
};
