#ifndef LIB_FIBER_INCLUDE_H
#define LIB_FIBER_INCLUDE_H

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32) || defined (_WIN64)
# include <winsock2.h>

typedef long ssize_t;

# define	FIBER_ETIMEDOUT		WSAETIMEDOUT
# define	FIBER_ENOMEM		WSAENOBUFS
# define	FIBER_EINVAL		WSAEINVAL
# define	FIBER_ECONNREFUSED	WSAECONNREFUSED
# define	FIBER_ECONNRESET	WSAECONNRESET
# define	FIBER_EHOSTDOWN		WSAEHOSTDOWN
# define	FIBER_EHOSTUNREACH	WSAEHOSTUNREACH
# define	FIBER_EINTR		WSAEINTR
# define	FIBER_ENETDOWN		WSAENETDOWN
# define	FIBER_ENETUNREACH	WSAENETUNREACH
# define	FIBER_ENOTCONN		WSAENOTCONN
# define	FIBER_EISCONN		WSAEISCONN
# define	FIBER_EWOULDBLOCK	WSAEWOULDBLOCK
# define	FIBER_EAGAIN		FIBER_EWOULDBLOCK	/* xxx */
# define	FIBER_ENOBUFS		WSAENOBUFS
# define	FIBER_ECONNABORTED	WSAECONNABORTED
# define	FIBER_EINPROGRESS	WSAEINPROGRESS

#else
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <poll.h>
#include <sys/select.h>

# define	FIBER_ETIMEDOUT		ETIMEDOUT
# define	FIBER_ENOMEM		ENOMEM
# define	FIBER_EINVAL		EINVAL
# define	FIBER_ECONNREFUSED	ECONNREFUSED
# define	FIBER_ECONNRESET	ECONNRESET
# define	FIBER_EHOSTDOWN		EHOSTDOWN
# define	FIBER_EHOSTUNREACH	EHOSTUNREACH
# define	FIBER_EINTR		EINTR
# define	FIBER_EAGAIN		EAGAIN
# define	FIBER_ENETDOWN		ENETDOWN
# define	FIBER_ENETUNREACH	ENETUNREACH
# define	FIBER_ENOTCONN		ENOTCONN
# define	FIBER_EISCONN		EISCONN
# define	FIBER_EWOULDBLOCK	EWOULDBLOCK
# define	FIBER_ENOBUFS		ENOBUFS
# define	FIBER_ECONNABORTED	ECONNABORTED
# define	FIBER_EINPROGRESS	EINPROGRESS

#endif

#ifdef FIBER_LIB
# ifndef FIBER_API
#  define FIBER_API
# endif
#elif defined(FIBER_DLL) || defined(_WINDLL)
# if defined(FIBER_EXPORTS) || defined(fiber_EXPORTS)
#  ifndef FIBER_API
#   define FIBER_API __declspec(dllexport)
#  endif
# elif !defined(FIBER_API)
#  define FIBER_API __declspec(dllimport)
# endif
#elif !defined(FIBER_API)
# define FIBER_API
#endif

/**
 * Э̽ṹ
 */
typedef struct ACL_FIBER ACL_FIBER;

/**
 * ǷҪ hook ϵͳе IO ص APIڲȱʡֵΪ 1
 * @param onoff {int} ǷҪ hook
 */
FIBER_API void acl_fiber_hook_api(int onoff);

/**
 * һЭ
 * @param fn {void (*)(ACL_FIBER*, void*)} ЭʱĻصַ
 * @param arg {void*} ص fn ʱĵڶ
 * @param size {size_t} ЭռջռС
 * @return {ACL_FIBER*}
 */
FIBER_API ACL_FIBER* acl_fiber_create(void (*fn)(ACL_FIBER*, void*),
	void* arg, size_t size);

/**
 * صǰ߳д״̬Э
 * @retur {int}
 */
FIBER_API int acl_fiber_ndead(void);

FIBER_API void acl_fiber_check_timer(size_t max);

/**
 * صǰеЭ̶
 * @retur {ACL_FIBER*}  NULL ʾǰûеЭ
 */
FIBER_API ACL_FIBER* acl_fiber_running(void);

/**
 * Э̵Э ID 
 * @param fiber {const ACL_FIBER*} acl_fiber_create Э̶󣬱ǿ
 * @return {unsigned int} Э ID 
 */
FIBER_API unsigned int acl_fiber_id(const ACL_FIBER* fiber);

/**
 * õǰеЭ̵ ID 
 * @return {unsigned int} ǰЭ̵ ID 
 */
FIBER_API unsigned int acl_fiber_self(void);

/**
 * Э̵Ĵ
 * @param fiber {ACL_FIBER*} ָЭ̶Ϊ NULL ʹõǰеЭ
 * @param errnum {int} 
 */
FIBER_API void acl_fiber_set_errno(ACL_FIBER* fiber, int errnum);

/**
 * ָЭ̵Ĵ
 * @param fiber {ACL_FIBER*} ָЭ̶Ϊ NULL ʹõǰЭ̶
 * @return {int} Э̴
 */
FIBER_API int acl_fiber_errno(ACL_FIBER* fiber);

/**
 * õǰϵͳ errno 
 * @return {int}
 */
FIBER_API int acl_fiber_sys_errno(void);

/**
 * õǰϵͳ errno 
 * @param errnum {int}
 */
FIBER_API void acl_fiber_sys_errno_set(int errnum);

/**
 * Ƿ񱣳ָЭ̵ĴţΪ֡Эֵ̽ǰ״̬µ
 * ţ֮Э̵Ĵ errno ٸı䣬ߵٴεñȡ
 * @param fiber {ACL_FIBER*} ָЭ̶Ϊ NULL ʹõǰеЭ
 * @param yesno {int} Ƿ񱣳
 */
FIBER_API void acl_fiber_keep_errno(ACL_FIBER* fiber, int yesno);

/**
 * ָЭ̵ĵǰ״̬
 * @param fiber {const ACL_FIBER*} ָЭ̶Ϊ NULL ʹõǰЭ
 * @return {int} Э״̬
 */
FIBER_API int acl_fiber_status(const ACL_FIBER* fiber);

/**
 * ֪ͨ״̬Э˳ 
 * @param fiber {const ACL_FIBER*} ָЭ̶󣬱 NULL
 */
FIBER_API void acl_fiber_kill(ACL_FIBER* fiber);

/**
 * 鱾ЭǷЭ֪ͨ˳
 * @param fiber {const ACL_FIBER*} ָЭ̶Ϊ NULL Զʹõǰ
 *  еЭ
 * @return {int} ֵΪ 0 ʾûб֪ͨ˳ 0 ʾ֪ͨ˳
 */
FIBER_API int acl_fiber_killed(ACL_FIBER* fiber);

/**
 *  IO ԭߵЭ
 * @param fiber {const ACL_FIBER*} Э̶󣬱 NULL
 * @param signum {int} SIGINT, SIGKILL, SIGTERM ... οϵͳ bits/signum.h
 */
FIBER_API void acl_fiber_signal(ACL_FIBER* fiber, int signum);

/**
 * Э̷͸ָЭ̵źֵ
 * @param fiber {const ACL_FIBER*} ָЭ̶Ϊ NULL ʱʹõǰЭ
 * @retur {int} ָЭյźֵ
 */
FIBER_API int acl_fiber_signum(ACL_FIBER* fiber);

/**
 * ǰеЭ̹ɵѡһҪеЭ
 * @return {int}
 */
FIBER_API int acl_fiber_yield(void);

/**
 * ָЭ̶ж
 * @param fiber {ACL_FIBER*} ָЭ̣ NULL
 */
FIBER_API void acl_fiber_ready(ACL_FIBER* fiber);

/**
 * ǰеЭ̹ͬʱִеȴһеЭ
 */
FIBER_API void acl_fiber_switch(void);

/**
 * õǰ̵߳Э̵ǷΪģʽģʽЭ̺ǷЭ
 * ״̬Э̵״̬ԶЭ̹̣粻ñڲȱʡ
 * ΪԶģʽ
 */
FIBER_API void acl_fiber_schedule_init(int on);

/**
 * ñЭ̵ĵȹ
 */
FIBER_API void acl_fiber_schedule(void);

/**
 * ָ¼Э̵ڲȱʡ¼Ϊ FIBER_EVENT_KERNEL
 * @param event_mode {int} ¼ͣμFIBER_EVENT_XXX
 */
#define FIBER_EVENT_KERNEL	0	/* epoll/kqueue	*/
#define FIBER_EVENT_POLL	1	/* poll		*/
#define FIBER_EVENT_SELECT	2	/* select	*/
#define FIBER_EVENT_WMSG	3	/* win message	*/
FIBER_API void acl_fiber_schedule_with(int event_mode);

/**
 * Э̵ʱ¼
 * @param event_mode {int} ¼ͣμFIBER_EVENT_XXX
 */
FIBER_API void acl_fiber_schedule_set_event(int event_mode);

/**
 * ñ⵱ǰ߳ǷЭ̵״̬
 * @return {int} 0 ʾЭ״̬ 0 ʾЭ̵״̬
 */
FIBER_API int acl_fiber_scheduled(void);

/**
 * ֹͣЭ̹
 */
FIBER_API void acl_fiber_schedule_stop(void);

/**
 * ʹǰеЭָ
 * @param milliseconds {unsigned int} ָҪߵĺ
 * @return {unsigned int} ЭߺٴαѺʣĺ
 */
FIBER_API unsigned int acl_fiber_delay(unsigned int milliseconds);

/**
 * ʹǰеЭָ
 * @param seconds {unsigned int} ָҪߵ
 * @return {unsigned int} ЭߺٴαѺʣ
 */
FIBER_API unsigned int acl_fiber_sleep(unsigned int seconds);

/**
 * һЭʱ
 * @param milliseconds {unsigned int} ʱѵĺ
 * @param size {size_t} Э̵ջռС
 * @param fn {void (*)(ACL_FIBER*, void*)} ʱЭ̱ʱĻص
 * @param ctx {void*} ص fn ʱĵڶ
 * @return {ACL_FIBER*} ´ĶʱЭ
 */
FIBER_API ACL_FIBER* acl_fiber_create_timer(unsigned int milliseconds,
	size_t size, void (*fn)(ACL_FIBER*, void*), void* ctx);

/**
 * ڶʱЭδǰͨøЭ̱ѵʱ
 * @param timer {ACL_FIBER*}  acl_fiber_create_timer ĶʱЭ
 * @param milliseconds {unsigned int} ָöʱЭ̱ѵĺ
 */
FIBER_API void acl_fiber_reset_timer(ACL_FIBER* timer, unsigned int milliseconds);

/**
 *  DNS ĵַ
 * @param ip {const char*} DNS  IP ַ
 * @param port {int} DNS Ķ˿
 */
FIBER_API void acl_fiber_set_dns(const char* ip, int port);

/* for fiber specific */

/**
 * 趨ǰЭ̵ľֲ
 * @param key {int*} Эֲ̾ĵַʼʱֵӦ <= 0ڲԶ
 *  һ > 0 õֵַЭ̿ԸøֵøԵ
 *  ֲָ NULL
 * @param ctx {void *} Эֲ̾
 * @param free_fn {void (*)(void*)} Э˳ʱô˺ͷЭֲ̾
 * @return {int} õЭֲ̾ļֵ -1 ʾǰЭ̲
 */
FIBER_API int acl_fiber_set_specific(int* key, void* ctx, void (*free_fn)(void*));

/**
 * õǰЭֲ̾
 * @param key {int}  acl_fiber_set_specific صļֵ
 * @retur {void*}  NULL ʾ
 */
FIBER_API void* acl_fiber_get_specific(int key);

/* fiber locking */

/**
 * Э̷̻߳ǰȫֻͬһ߳
 */
typedef struct ACL_FIBER_MUTEX ACL_FIBER_MUTEX;

/**
 * Э̶д̷߳ǰȫֻͬһ߳
 */
typedef struct ACL_FIBER_RWLOCK ACL_FIBER_RWLOCK;

/**
 * Э̷̻߳ǰȫֻͬһ߳
 * @return {ACL_FIBER_MUTEX*}
 */
FIBER_API ACL_FIBER_MUTEX* acl_fiber_mutex_create(void);

/**
 * ͷЭ̻
 * @param l {ACL_FIBER_MUTEX*}  acl_fiber_mutex_create Э̻
 */
FIBER_API void acl_fiber_mutex_free(ACL_FIBER_MUTEX* l);

/**
 * Э̻ʽɹ򷵻أ
 * @param l {ACL_FIBER_MUTEX*}  acl_fiber_mutex_create Э̻
 */
FIBER_API void acl_fiber_mutex_lock(ACL_FIBER_MUTEX* l);

/**
 * Э̻ԽмǷɹ
 * @param l {ACL_FIBER_MUTEX*}  acl_fiber_mutex_create Э̻
 * @return {int} ɹ򷵻 0 ֵ򷵻 -1
 */
FIBER_API int acl_fiber_mutex_trylock(ACL_FIBER_MUTEX* l);

/**
 * ɹЭ̵ñнñЭ̱Ǹ
 * ڲ
 * @param l {ACL_FIBER_MUTEX*}  acl_fiber_mutex_create Э̻
 */
FIBER_API void acl_fiber_mutex_unlock(ACL_FIBER_MUTEX* l);

/**
 * Э̶д̷߳ǰȫֻͬһ߳
 * @return {ACL_FIBER_RWLOCK*}
 */
FIBER_API ACL_FIBER_RWLOCK* acl_fiber_rwlock_create(void);

/**
 * ͷЭ̶д
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 */
FIBER_API void acl_fiber_rwlock_free(ACL_FIBER_RWLOCK* l);

/**
 * Э̶дӶǰЭ̼˶ЭȻ
 * ӶǰЭ̼дЭ̽״ֱ̬
 * дͷ
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 */
FIBER_API void acl_fiber_rwlock_rlock(ACL_FIBER_RWLOCK* l);

/**
 * Э̶дԼӶǷɹ
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 * @retur {int}  1 ʾɹ 0 ʾʧ
 */
FIBER_API int acl_fiber_rwlock_tryrlock(ACL_FIBER_RWLOCK* l);

/**
 * Э̶ддֻеδκЭ̼Ӷ/дʱŻ᷵أ
 * ֱɼд
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 */
FIBER_API void acl_fiber_rwlock_wlock(ACL_FIBER_RWLOCK* l);

/**
 * Э̶дԼдǷɹ
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 * @return {int}  1 ʾдɹ 0 ʾʧ
 */
FIBER_API int acl_fiber_rwlock_trywlock(ACL_FIBER_RWLOCK* l);

/**
 * Э̶дɹӶЭ̵ñ֮߱ǰѳɹӶ
 * ɹЭ
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 */
FIBER_API void acl_fiber_rwlock_runlock(ACL_FIBER_RWLOCK* l);
/**
 * Э̶дɹдЭ̵ñд֮߱ǰѳɹд
 * ɹЭ
 * @param l {ACL_FIBER_RWLOCK*}  acl_fiber_rwlock_create Ķд
 */
FIBER_API void acl_fiber_rwlock_wunlock(ACL_FIBER_RWLOCK* l);

/* fiber_event.c */

/* ̰߳ȫЭڲ̵ͬ߳Э֮估֮ͬ߳Ļ */
typedef struct ACL_FIBER_EVENT ACL_FIBER_EVENT;

/**
 * ¼Э/̻߳
 * @return {ACL_FIBER_EVENT *}
 */
FIBER_API ACL_FIBER_EVENT *acl_fiber_event_create(void);

/**
 * ͷ¼
 * @param {ACL_FIBER_EVENT *}
 */
FIBER_API void acl_fiber_event_free(ACL_FIBER_EVENT *event);

/**
 * ȴ¼
 * @param {ACL_FIBER_EVENT *}
 * @return {int}  0 ʾɹ-1 ʾ
 */
FIBER_API int acl_fiber_event_wait(ACL_FIBER_EVENT *event);

/**
 * Եȴ¼
 * @param {ACL_FIBER_EVENT *}
 * @return {int}  0 ʾɹ-1 ʾռ
 */
FIBER_API int acl_fiber_event_trywait(ACL_FIBER_EVENT *event);

/**
 * ¼ӵ֪ͨȴ¼ãȴյ֪ͨɻ¼
 * @param {ACL_FIBER_EVENT *}
 * @return {int}  0 ʾɹ-1 ʾ
 */
FIBER_API int acl_fiber_event_notify(ACL_FIBER_EVENT *event);

/* fiber semaphore */

typedef struct ACL_FIBER_SEM ACL_FIBER_SEM;

/**
 * ЭźͬʱڲὫǰ߳ź
 * @param num {int} źʼֵ >= 0
 * @return {ACL_FIBER_SEM *}
 */
FIBER_API ACL_FIBER_SEM* acl_fiber_sem_create(int num);

/**
 * ͷЭź
 * @param {ACL_FIBER_SEM *}
 */
FIBER_API void acl_fiber_sem_free(ACL_FIBER_SEM* sem);

/**
 * õǰЭź󶨵߳ ID
 * @param sem {ACL_FIBER_SEM*} Эź
 * @return {unsigned long}
 */
#if !defined(_WIN32) && !defined(_WIN64)
FIBER_API unsigned long acl_fiber_sem_get_tid(ACL_FIBER_SEM* sem);
#endif

/**
 * ָЭźĵ߳ IDı䱾Эź߳ʱȴЭ
 * ݷ 0 ڲԶ fatalЭźϵȴЭ̷ǿʱֹñ
 * @param sem {ACL_FIBER_SEM*} Эź
 * @param {unsigned long} ߳ ID
 */
FIBER_API void acl_fiber_sem_set_tid(ACL_FIBER_SEM* sem, unsigned long tid);

/**
 * Эź > 0 ʱʹź 1ȴź > 0
 * @param sem {ACL_FIBER_SEM *}
 * @retur {int} źǰֵ -1 ǰ߳Эź߳
 *  ͬһ̣߳ʱ÷ȴ
 */
FIBER_API int acl_fiber_sem_wait(ACL_FIBER_SEM* sem);

/**
 * ʹЭź 1
 * @param sem {ACL_FIBER_SEM *}
 * @retur {int} ɹ 1 ʱֵ >= 0 -1 ʾǰźãǰ
 *  ߳Эź̲߳ͬһ߳
 */
FIBER_API int acl_fiber_sem_trywait(ACL_FIBER_SEM* sem);

/**
 * ʹЭź 1
 * @param sem {ACL_FIBER_SEM *}
 * @retur {int} źǰֵ -1 ʾǰ߳Эź
 *  ̲߳ͬһ߳
 */
FIBER_API int acl_fiber_sem_post(ACL_FIBER_SEM* sem);

/**
 * ָЭźĵǰֵֵӳĿǰȴź
 * @param sem {ACL_FIBER_SEM*}
 * @retur {int}
 */
FIBER_API int acl_fiber_sem_num(ACL_FIBER_SEM* sem);

/* channel communication */

/**
 * Э̼ͨŵĹܵ
 */
typedef struct ACL_CHANNEL ACL_CHANNEL;

/**
 * ЭͨŹܵ
 * @param elemsize {int}  ACL_CHANNEL дĶĹ̶ߴСֽڣ
 * @param bufsize {int} ACL_CHANNEL ڲСԻ elemsize ߴС
 *  ĸ
 * @return {CHANNNEL*}
 */
FIBER_API ACL_CHANNEL* acl_channel_create(int elemsize, int bufsize);

/**
 * ͷ acl_channel_create ЭͨŹܵ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 */
FIBER_API void acl_channel_free(ACL_CHANNEL* c);

/**
 * ʽָ ACL_CHANNEL зָĶַ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} ͵Ķַ
 * @return {int} ֵ >= 0
 */
FIBER_API int acl_channel_send(ACL_CHANNEL* c, void* v);

/**
 * ʽָ ACL_CHANNEL зָĶڲ acl_channel_create ָ
 *  elemsize Сݿ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} ͵Ķַ
 */
FIBER_API int acl_channel_send_nb(ACL_CHANNEL* c, void* v);

/**
 * ָ ACL_CHANNEL ʽȡ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} Ž
 * @return {int} ֵ >= 0 ʾɹ
 */
FIBER_API int acl_channel_recv(ACL_CHANNEL* c, void* v);

/**
 * ָ ACL_CHANNEL зʽȡǷݶ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} Ž
 * @return {int} ֵ >= 0 ʾɹݣʾδ
 */
FIBER_API int acl_channel_recv_nb(ACL_CHANNEL* c, void* v);

/**
 * ָ ACL_CHANNEL ʽָĵַ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} Ͷĵַ
 * @return {int} ֵ >= 0
 */
FIBER_API int acl_channel_sendp(ACL_CHANNEL* c, void* v);

/**
 * ָ CHANNLE ʽ acl_channel_sendp ͵Ķĵַ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @return {void*} ط NULLָյĶĵַ
 */
FIBER_API void *acl_channel_recvp(ACL_CHANNEL* c);

/**
 * ָ ACL_CHANNEL зʽָĵַ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param v {void*} Ͷĵַ
 * @return {int} ֵ >= 0
 */
FIBER_API int acl_channel_sendp_nb(ACL_CHANNEL* c, void* v);

/**
 * ָ CHANNLE ʽ acl_channel_sendp ͵Ķĵַ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @return {void*} ط NULLָյĶĵַ NULL ʾ
 *  ûжκζ
 */
FIBER_API void *acl_channel_recvp_nb(ACL_CHANNEL* c);

/**
 * ָ ACL_CHANNEL з޷ųֵ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param val {unsigned long} Ҫ͵ֵ
 * @return {int} ֵ >= 0
 */
FIBER_API int acl_channel_sendul(ACL_CHANNEL* c, unsigned long val);

/**
 * ָ ACL_CHANNEL н޷ųֵ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @return {unsigned long}
 */
FIBER_API unsigned long acl_channel_recvul(ACL_CHANNEL* c);

/**
 * ָ ACL_CHANNEL Էʽ޷ųֵ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @param val {unsigned long} Ҫ͵ֵ
 * @return {int} ֵ >= 0
 */
FIBER_API int acl_channel_sendul_nb(ACL_CHANNEL* c, unsigned long val);

/**
 * ָ ACL_CHANNEL Էʽ޷ųֵ
 * @param c {ACL_CHANNEL*}  acl_channel_create Ĺܵ
 * @return {unsigned long}
 */
FIBER_API unsigned long acl_channel_recvul_nb(ACL_CHANNEL* c);

/**************************** fiber wrapper *********************************/
#if defined(_WIN32) || defined(_WIN64)
typedef SOCKET socket_t;
typedef int socklen_t;
#else
typedef int socket_t;
#define INVALID_SOCKET	-1
#endif

FIBER_API socket_t acl_fiber_socket(int domain, int type, int protocol);
FIBER_API int acl_fiber_listen(socket_t, int backlog);

#if defined(_WIN32) || defined(_WIN64)
FIBER_API int WINAPI acl_fiber_close(socket_t fd);
FIBER_API socket_t WINAPI acl_fiber_accept(
	socket_t, struct sockaddr *, socklen_t *);
FIBER_API int WINAPI acl_fiber_connect(
	socket_t , const struct sockaddr *, socklen_t );

FIBER_API int WINAPI acl_fiber_recv(
	socket_t, char* buf, int len, int flags);
FIBER_API int WINAPI acl_fiber_recvfrom(socket_t, char* buf, size_t len,
	int flags, struct sockaddr* src_addr, socklen_t* addrlen);

FIBER_API int WINAPI acl_fiber_send(socket_t, const char* buf,
	int len, int flags);
FIBER_API int WINAPI acl_fiber_sendto(socket_t, const char* buf, size_t len,
	int flags, const struct sockaddr* dest_addr, socklen_t addrlen);

FIBER_API int WINAPI acl_fiber_select(int nfds, fd_set *readfds,
	fd_set *writefds, fd_set *exceptfds, const struct timeval *timeout);
FIBER_API int WINAPI acl_fiber_poll(struct pollfd *fds,
	unsigned long nfds, int timeout);
#else
FIBER_API int acl_fiber_close(socket_t fd);
FIBER_API socket_t acl_fiber_accept(socket_t , struct sockaddr *, socklen_t *);
FIBER_API int acl_fiber_connect(socket_t , const struct sockaddr *, socklen_t );
FIBER_API ssize_t acl_fiber_read(socket_t, void* buf, size_t count);
FIBER_API ssize_t acl_fiber_readv(socket_t, const struct iovec* iov, int iovcnt);
FIBER_API ssize_t acl_fiber_recvmsg(socket_t, struct msghdr* msg, int flags);

FIBER_API ssize_t acl_fiber_write(socket_t, const void* buf, size_t count);
FIBER_API ssize_t acl_fiber_writev(socket_t, const struct iovec* iov, int iovcnt);
FIBER_API ssize_t acl_fiber_sendmsg(socket_t, const struct msghdr* msg, int flags);

FIBER_API ssize_t acl_fiber_recv(socket_t, void* buf, size_t len, int flags);
FIBER_API ssize_t acl_fiber_recvfrom(socket_t, void* buf, size_t len, int flags,
	struct sockaddr* src_addr, socklen_t* addrlen);

FIBER_API ssize_t acl_fiber_send(socket_t, const void* buf, size_t len, int flags);
FIBER_API ssize_t acl_fiber_sendto(socket_t, const void* buf, size_t len, int flags,
	const struct sockaddr* dest_addr, socklen_t addrlen);

FIBER_API int acl_fiber_select(int nfds, fd_set *readfds, fd_set *writefds,
	fd_set *exceptfds, struct timeval *timeout);
FIBER_API int acl_fiber_poll(struct pollfd *fds, nfds_t nfds, int timeout);
#endif

/****************************************************************************/

/**
 * ڽд־־ļǰصûԶĺҽ־Ϣݸú
 * ֻеûͨ msg_pre_write úЧ
 * @param ctx {void*} ûԶ
 * @param fmt {const char*} ʽ
 * @param ap {va_list} ʽб
 */
typedef void (*FIBER_MSG_PRE_WRITE_FN)(void *ctx, const char *fmt, va_list ap);

/**
 * Ӧͨ˺ͿԶ־¼Ӧڴ־ǰ
 * msg_register עԶ¼Ӧд־ʱôԶ
 * ¼־ȱʡ־¼
 * @param ctx {void*} ӦôݽȥĲ
 * @param fmt {const char*} ʽ
 * @param ap {va_list} б
 */
typedef void (*FIBER_MSG_WRITE_FN) (void *ctx, const char *fmt, va_list ap);

/**
 * ڴ־ǰô˺עӦԼ־¼
 * @param write_fn {MSG_WRITE_FN} Զ־¼
 * @param ctx {void*} Զ
 */
FIBER_API void acl_fiber_msg_register(FIBER_MSG_WRITE_FN write_fn, void *ctx);

/**
 *  msg_register עԶ庯ȱʡ־
 */
FIBER_API void acl_fiber_msg_unregister(void);

/**
 * ڴ־ǰô˺עӦõ˽кڼ¼־ǰȼ¼Ϣͨ
 * עĺݸӦ
 * @param pre_write {MSG_PRE_WRITE_FN} ־¼ǰõĺ
 * @param ctx {void*} Զ
 */
FIBER_API void acl_fiber_msg_pre_write(FIBER_MSG_PRE_WRITE_FN pre_write, void *ctx);

/**
 * δ msg_open ʽ־ʱ msg_info/error/fatal/warn
 * ĲǷϢ׼Ļϣͨ˺øÿأÿ
 * ӰǷҪϢնĻӰǷļ
 * @param onoff {int}  0 ʾĻ
 */
FIBER_API void acl_fiber_msg_stdout_enable(int onoff);

/**
 * ϴϵͳóʱĴ
 * @return {int} 
 */
FIBER_API int acl_fiber_last_error(void);

/**
 * ֹô
 * @param errnum {int} 
 */
void acl_fiber_set_error(int errnum);

/****************************************************************************/

#ifdef __cplusplus
}
#endif

#endif
